//--- K.I.LIB ---
// kl_wcmn.h : windows-common-interface operatin

#include "stdafx.h"
#include "kilib.h"

static int CALLBACK __ki__ofp( HWND w, UINT m, LPARAM l, LPARAM d )
{
	if( m==BFFM_INITIALIZED && d )
		::SendMessage( w, BFFM_SETSELECTION, TRUE, d );
	return 0;
}

bool kiSUtil::getFolderDlg( char* buf, HWND par, const char* title, const char* def )
{
	// Zbg
	BROWSEINFO bi;
	ki_memzero( &bi, sizeof(bi) );
	bi.hwndOwner      = par;
	bi.pszDisplayName = buf;
	bi.lpszTitle      = title;
	bi.ulFlags        = BIF_RETURNONLYFSDIRS | BIF_DONTGOBELOWDOMAIN;
	bi.lpfn           = __ki__ofp;
	bi.lParam         = (long)def;

	// _CAO\
	ITEMIDLIST* id = SHBrowseForFolder( &bi );
	if( id==NULL )
		return false;
	SHGetPathFromIDList( id, buf );
	app()->shellFree( id );

	// I
	return true;
}

void kiSUtil::getFolderDlgOfEditBox( HWND wnd, HWND par, const char* title )
{
	char str[MAX_PATH];
	::SendMessage( wnd, WM_GETTEXT, MAX_PATH, (LPARAM)str );
	char* l=str;
	for( char* x=str; *x; x=kiStr::next(x) )
		l=x;
	if( *l=='\\' || *l=='/' )
		*l='\0';
	if( getFolderDlg( str, par, title, str ) )
		::SendMessage( wnd, WM_SETTEXT, 0, (LPARAM)str );
}

int kiSUtil::getSysIcon( const char* ext )
{
	SHFILEINFO fi;
	::SHGetFileInfo(
		kiPath("test.")+=ext, 0, &fi, sizeof(fi),
		SHGFI_USEFILEATTRIBUTES | SHGFI_SYSICONINDEX | SHGFI_ICON | SHGFI_SMALLICON );
	return fi.iIcon;
}

void kiSUtil::msgLastError()
{
	char* pMsg;
	::FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,::GetLastError(),MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),(LPTSTR)&pMsg,0,NULL );
	app()->msgBox( pMsg );
	::LocalFree( pMsg );
}

void kiSUtil::createShortCut( const kiPath& at, const char* name )
{
	::CoInitialize(NULL);

	IShellLink* psl;
	if( SUCCEEDED(::CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,IID_IShellLink,(void**)&psl)) )
	{
		psl->SetPath( kiPath(kiPath::Exe_name) );
		psl->SetWorkingDirectory( kiPath(kiPath::Exe,false) );

		IPersistFile* ppf;
		if( SUCCEEDED(psl->QueryInterface(IID_IPersistFile,(void**)&ppf)) )
		{
			WORD wsz[MAX_PATH]; 
			kiPath lnkfile( at );
			lnkfile += name, lnkfile += ".lnk";
			::MultiByteToWideChar(CP_ACP,0,lnkfile,-1,(LPWSTR)wsz,MAX_PATH);
			ppf->Save((LPCOLESTR)wsz,TRUE);
			ppf->Release();
		}
		psl->Release();
	}
	::CoUninitialize();
}

bool kiSUtil::exist( const char* fname )
{
	return 0xffffffff != ::GetFileAttributes( fname );
}

bool kiSUtil::isdir( const char* fname )
{
	DWORD attr = ::GetFileAttributes( fname );
	return attr!=0xffffffff && (attr&FILE_ATTRIBUTE_DIRECTORY);
}

// }caldixF
// t@CQƃ_CAO蔲
bool kiSUtil::getOpenFileNameDlg(HWND hwnd,char *rfn)
{
	OPENFILENAME  ofn;
	
	ZeroMemory((LPVOID)&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = "AvP[V(*.exe)\0*.exe\0SẴt@C(*.*)\0*.*\0\0";
	ofn.lpstrFile = rfn;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_EXPLORER;
	ofn.lpfnHook = NULL;
	// Ȃ񂩎Ă
	if (GetOpenFileName(&ofn)){
		lstrcpy(rfn,ofn.lpstrFile);
		return TRUE;
	}
	
	return FALSE;
}

void kiSUtil::getOpenFileNameDlgOfEditBox(HWND wnd,HWND par)
{
	char str[MAX_PATH];
	
	str[0] = '\0';
	::SendMessage( wnd, WM_GETTEXT, MAX_PATH, (LPARAM)str );
	if( getOpenFileNameDlg(par,str) )
		::SendMessage( wnd, WM_SETTEXT, 0, (LPARAM)str );
}
// }܂caldixF
